-- CONSULTA DE RECEITAS DIRETAS DA TELA
select
    cast(nt.numdocumento as varchar(30)) as numero_nota,
    nt.dtentradasaida as data,
    cast(pes.nome as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(ni.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.numero as varchar(30)) as numero_centro_custo,
    cast(cc.descricao as varchar(50)) as nome_centro_custo,
    cast(sa.descricao as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(nia.percentual as decimal(3,2)) as percentual,
    cast(((ni.vrtotal / 100)*nia.percentual) as decimal(15,2)) as valor_apropriado,
                                cast(pat.descricao as varchar(50)) as nome_patrimonio
from
    notaitem ni
    join nota nt on nt.cdnota = ni.cdnota
    left join notaitemapro nia on nia.cdnotaitem = ni.cdnotaitem
    join produto pr on pr.cdproduto = ni.cdproduto
    left join centrocusto cc on cc.cdcentrocusto = nia.cdcentrocusto
    join contagerencial cg on cg.cdcontagerencial = ni.cdcontagerencial
    join pessoa pes on pes.cdpessoa = nt.cdpessoa
    left join patrimonio pat on pat.cdpatrimonio = ni.cdpatrimonio
    left join safra sa on sa.cdsafra = nia.cdsafra
    left join atividade ati on ati.cdatividade = ni.cdatividade
where
    nt.tiponota = 'S'
    and ni.saidaimediata = '0'
    and ni.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)
------ALTERAR AQUI O PERÍODO CONFORME DESEJADO - COLOCAR MESES INTEIROS - MANTENHA O FORMATO DA DATA
    and nt.dtentradasaida>='2000-01-01'
    and nt.dtentradasaida<='2090-01-01' 

UNION ALL

-- CONSULTA DE RECEITAS DE PRODUÇÃO
select
    cast('Estoque' as varchar(30))as numero_nota,
    mo.data as data,
    cast('Estoque' as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(mo.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.numero as varchar(30)) as numero_centro_custo,
    cast(cc.descricao as varchar(50)) as nome_centro_custo,
    cast(sa.descricao as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(100 as decimal(3,2)) as percentual,
    cast(mo.vrtotal as decimal(15,2)) as valor_apropriado,
    cast(pat.descricao as varchar(50)) as nome_patrimonio
from
    movimentoestoque mo
    join produto pr on pr.cdproduto = mo.cdproduto
    join contagerencial cg on cg.cdcontagerencial = mo.cdcontagerencial
    left join centrocusto cc on cc.cdcentrocusto = mo.cdcentrocusto
    left join patrimonio pat on pat.cdpatrimonio = mo.cdpatrimonio
    left join safra sa on sa.cdsafra = mo.cdsafra
    left join atividade ati on ati.cdatividade = mo.cdatividade
where
    mo.cdtipomovimentoestoque = 4 and
    mo.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)
------ALTERAR AQUI O PERÍODO CONFORME DESEJADO - COLOCAR MESES INTEIROS - MANTENHA O FORMATO DA DATA
    and mo.data>='2000-01-01'
    and mo.data<='2090-01-01'
UNION ALL

-- CONSULTA DE CUSTOS A PARTIR DAS SAÍDAS DE ESTOQUE
select
    cast('Estoque' as varchar(30))as numero_nota,
    mo.data as data,
    cast('Estoque' as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(mo.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.numero as varchar(30)) as numero_centro_custo,
    cast(cc.descricao as varchar(50)) as nome_centro_custo,
    cast(sa.descricao as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(100 as decimal(3,2)) as percentual,
    cast((((select customedio from sp_customedio(mo.data,mo.cdproduto)) * mo.qtde) * -1) as decimal(15,2)) as valor_apropriado,
    cast(pat.descricao as varchar(50)) as nome_patrimonio
from
    movimentoestoque mo
    join produto pr on pr.cdproduto = mo.cdproduto
    join contagerencial cg on cg.cdcontagerencial = mo.cdcontagerencial
    left join centrocusto cc on cc.cdcentrocusto = mo.cdcentrocusto
    left join patrimonio pat on pat.cdpatrimonio = mo.cdpatrimonio
    left join safra sa on sa.cdsafra = mo.cdsafra
    left join atividade ati on ati.cdatividade = mo.cdatividade
where
    mo.cdtipomovimentoestoque in (7,8,9,10) and
    mo.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)
------ALTERAR AQUI O PERÍODO CONFORME DESEJADO - COLOCAR MESES INTEIROS - MANTENHA O FORMATO DA DATA
    and mo.data>='2000-01-01'
    and mo.data<='2090-01-01'
    
UNION ALL

-- CONSULTA DE CUSTOS A PARTIR DA TELA DE DESPESAS
select
    cast(nt.numdocumento as varchar(30)) as numero_nota,
    nt.dtentradasaida as data,
    cast(pes.nome as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(ni.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.numero as varchar(30)) as numero_centro_custo,
    cast(cc.descricao as varchar(50)) as nome_centro_custo,
    cast(sa.descricao as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(nia.percentual as decimal(3,2)) as percentual,
    cast((((ni.vrtotal / 100)*nia.percentual) * -1) as decimal(15,2)) as valor_apropriado,
    cast(pat.descricao as varchar(50)) as nome_patrimonio
from
    notaitem ni
    join nota nt on nt.cdnota = ni.cdnota
    left join notaitemapro nia on nia.cdnotaitem = ni.cdnotaitem
    join produto pr on pr.cdproduto = ni.cdproduto
    left join centrocusto cc on cc.cdcentrocusto = nia.cdcentrocusto
    join contagerencial cg on cg.cdcontagerencial = ni.cdcontagerencial
    join pessoa pes on pes.cdpessoa = nt.cdpessoa
    left join patrimonio pat on pat.cdpatrimonio = ni.cdpatrimonio
    left join safra sa on sa.cdsafra = nia.cdsafra
    left join atividade ati on ati.cdatividade = ni.cdatividade
where
    nt.tiponota = 'E' and
    ((nt.tipofiscal = 'N' and nt.cdnota not in (select re.cdnotavinculada from nota re where re.cdnotavinculada is not null)) or (nt.tipofiscal = 'I') )
    and ni.saidaimediata = '0'
    and ni.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)
------ALTERAR AQUI O PERÍODO CONFORME DESEJADO - COLOCAR MESES INTEIROS - MANTENHA O FORMATO DA DATA
    and nt.dtentradasaida>='2000-01-01'
    and nt.dtentradasaida<='2090-01-01'  
order by 1